Attribute VB_Name = "Module1"
Sub EventProc(ByVal hEvent As Long)
  Dim EventType As Integer
  
  EventType = lcPropGetInt(hEvent, LC_PROP_EVENT_TYPE)
  Select Case EventType
  Case LC_EVENT_MOUSEMOVE
    OnMouseMove (hEvent)
  Case LC_EVENT_LBDOWN
    OnMouseLBDown (hEvent)
  End Select
End Sub
Sub OnMouseMove(ByVal hEvent As Long)
  Dim hLcWnd As Long
  Dim Xdrw As Double, Ydrw As Double
  
  ' get handle of graphics window
  hLcWnd = lcPropGetHandle(hEvent, LC_PROP_EVENT_WND)
  ' get cursor position
  Xdrw = lcPropGetFloat(hLcWnd, LC_PROP_WND_CURX)
  Ydrw = lcPropGetFloat(hLcWnd, LC_PROP_WND_CURY)
  ' display the coordinates
  Form1.Text_X.Text = Str(Xdrw)
  Form1.Text_Y.Text = Str(Ydrw)
End Sub

Sub OnMouseLBDown(ByVal hEvent As Long)
  Dim hEntLcWnd As Long
  Dim bCtrl As Integer
  Dim Xdrw As Double, Ydrw As Double
  Dim Xwin As Double, Ywin As Double
  Dim Ang As Double
  
  ' get handle of graphics window
  hLcWnd = lcPropGetHandle(hEvent, LC_PROP_EVENT_WND)
  ' state of Ctrl key: 1-pressed, 0-released
  bCtrl = lcPropGetInt(hEvent, LC_PROP_EVENT_INT4)
  If bCtrl = 1 Then
    ' get cursor position (drawing's coordinates)
    Xdrw = lcPropGetFloat(hLcWnd, LC_PROP_WND_CURX)
    Ydrw = lcPropGetFloat(hLcWnd, LC_PROP_WND_CURY)
    ' get cursor coordinates (window coordinate space, pixels)
    Xwin = lcPropGetInt(hEvent, LC_PROP_EVENT_INT1)
    Ywin = lcPropGetInt(hEvent, LC_PROP_EVENT_INT2)
    ' get entity at cursor position
    hEnt = lcWndGetEntByPoint(hLcWnd, Xwin, Ywin)
    If hEnt <> 0 Then
      ' rotate picked entity
      Ang = 15 * LC_DEG_TO_RAD
      Call lcEntRotate(hEnt, Xdrw, Ydrw, Ang)
      Call lcWndRedraw(hLcWnd)
    End If
    ' return non-zero in order LiteCAD do not process the event
    Call lcEventReturnCode(1)
  End If
End Sub

